/* 
 * Copyright (c) 2002 The University of Wroclaw.
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Id: std.g,v 1.6 2002/05/27 15:08:40 malekith Exp $
 *
 * Runtime environment for Gont, Std module implementation.
 */


/* Just wrappers... */
extern_c void Std__exit(int);

/* ... and very simple functions... */
'a exit(int r)
{
	Std__exit(r); 
	raise Exit; 	// never reached
}

/* Stdout output. */
void print_int(int i)
{
	print_string(itoa(i)); 
}

void print_float(float f)
{
	print_string(ftoa(f)); 
}

void print_newline()
{
	print_string("\n");
}

void print_endline(string s)
{
	print_string(s);
	print_newline();
}

/* Stderr output. */
void prerr_int(int i)
{
	prerr_string(itoa(i)); 
}

void prerr_float(float f)
{
	prerr_string(ftoa(f)); 
}

void prerr_newline()
{
	prerr_string("\n");
}

void prerr_endline(string s)
{
	prerr_string(s);
	prerr_newline();
}

/* Input. */
int read_int()
{
	return atoi(read_line());
}

float read_float()
{
	return atof(read_line());
}

/* Raise shortcuts. */
'a fail_with(string s)
{
	raise Failure[s];
}

'a invalid_argument(string s)
{
	raise Invalid_argument[s];
}

/* Pair opertations. */
'a fst(*['a, 'b] p)
{
	switch p {
	case [a, _]: return a;
	}

	raise Match_failure;	// never reached
}

'b snd(*['a, 'b] p)
{
	switch p {
	case [_, a]: return a;
	}

	raise Match_failure;	// never reached
}

void __dummy_disaster()
{
	// make sure these are linked (other are referenced elsewhere in
	// this module)
	raise Null_access;
	raise Not_found;
	raise End_of_file;
}
