/* 
 * Copyright (c) 2002 The University of Wroclaw.
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Id: std.gi,v 1.6 2002/05/27 15:08:40 malekith Exp $
 *
 * Runtime environment for Gont, Std module interface.
 * 
 * This module is opened at the beginning of every compilation unit.
 */
 
string itoa(int) = "Std__itoa";
int atoi(string) = "Std__atoi";

string ftoa(float) = "Std__ftoa";
float atof(string) = "Std__atof";

void print_string(string) = "Std__print_string";
void print_int(int);
void print_float(float);
void print_endline(string);
void print_newline();

void prerr_string(string) = "Std__prerr_string";
void prerr_int(int);
void prerr_float(float);
void prerr_endline(string);
void prerr_newline();

string read_line() = "Std__read_line";
int read_int();
float read_float();

union <'a>option {
	void None;
	'a Some;
}

bool streq(string, string) = "gont_streq";
int strcmp(string, string) = "gont_strcmp";
string strjoin(string, string) = "gont_strjoin";

'a fst(*['a, 'b]);
'b snd(*['a, 'b]);

exception void Match_failure
exception void Null_access
exception string Invalid_argument
exception string Failure
exception void Not_found
exception void Exit
exception void End_of_file

'a invalid_argument(string);
'a fail_with(string);
'a exit(int);
void at_exit(*(void ())) = "Std__at_exit";

